<?php
//
// Definition of eZDHTMLXMLInput class
//
// Created on: <06-Nov-2002 15:10:02 wy>
//
// Copyright (C) 1999-2006 eZ systems as. All rights reserved.
//

/*! \file ezdhtmlxmlinput.php
*/

/*!
  \class eZDHTMLXMLInput
  \brief The class eZDHTMLXMLInput does

*/
include_once( "lib/ezxml/classes/ezxml.php" );
include_once( 'kernel/common/template.php' );
include_once( 'lib/eztemplate/classes/eztemplateincludefunction.php' );
/*include_once( "kernel/classes/datatypes/ezimage/ezimagevariation.php");
include_once( "kernel/classes/datatypes/ezimage/ezimage.php");
include_once( "lib/ezimage/classes/ezimagelayer.php" );
include_once( "lib/ezimage/classes/ezimagetextlayer.php" );
include_once( "lib/ezimage/classes/ezimagefont.php" );
include_once( "lib/ezimage/classes/ezimageobject.php" );
include_once( "lib/eztemplate/classes/eztemplateimageoperator.php" );
*/
include_once( "lib/ezutils/classes/ezini.php" );
include_once( "lib/ezutils/classes/ezsys.php" );
include_once( "kernel/classes/ezcontentobject.php");
include_once( 'kernel/classes/datatypes/ezurl/ezurlobjectlink.php' );

include_once( 'extension/ezdhtml/lib/system.php' );
include_once( 'extension/ezdhtml/ezinfo.php' );

datatype_class( 'ezxmltext', 'eZXMLInputHandler' );

class eZDHTMLXMLInput extends eZXMLInputHandler
{
    /*!
     Constructor
    */
    function eZDHTMLXMLInput( &$xmlData, $aliasedType, $contentObjectAttribute )
    {
        $this->eZXMLInputHandler( $xmlData, $aliasedType, $contentObjectAttribute );
        $contentIni =& eZINI::instance( 'content.ini' );
        if ( $contentIni->hasVariable( 'header', 'UseStrictHeaderRule' ) )
        {
            if ( $contentIni->variable( 'header', 'UseStrictHeaderRule' ) == "true" )
                $this->IsStrictHeader = true;
        }

        include_once( 'lib/version.php' );
        $this->eZPublishVersion = eZPublishSDK::majorVersion() + eZPublishSDK::minorVersion() * 0.1;

        $this->browserType = $this->browserSupportsDHTMLType();

        if ( $this->eZPublishVersion >= 3.8 )
        {
            $ini =& eZINI::instance( 'ezxml.ini' );
            if ( $ini->hasVariable( 'InputSettings', 'TrimSpaces' ) )
            {
                $trimSpaces = $ini->variable( 'InputSettings', 'TrimSpaces' );
                $this->trimSpaces = $trimSpaces == 'true' ? true : false;
            }
    
            if ( $ini->hasVariable( 'InputSettings', 'AllowMultipleSpaces' ) )
            {
                $allowMultipleSpaces = $ini->variable( 'InputSettings', 'AllowMultipleSpaces' );
                $this->allowMultipleSpaces = $allowMultipleSpaces == 'true' ? true : false;
            }
        }
        else
        {
            $this->trimSpaces = true;
            $this->allowMultipleSpaces = false;
        }
    }

    /*!
     \reimp
    */
    function hasAttribute( $name )
    {
        return ( $name == 'is_editor_enabled' or
                 $name == 'browser_supports_dhtml_type' or
                 $name == 'is_compatible_version' or
                 $name == 'version' or
                 $name == 'required_version' or
                 $name == 'ezpublish_version' or
                 eZXMLInputHandler::hasAttribute( $name ) );
    }

    /*!
     \reimp
    */
    function &attribute( $name )
    {
        if ( $name == 'is_editor_enabled' )
            $attr = eZDHTMLXMLInput::isEditorEnabled();
        else if ( $name == 'browser_supports_dhtml_type' )
            $attr = eZDHTMLXMLInput::browserSupportsDHTMLType();
        else if ( $name == 'is_compatible_version' )
            $attr = eZDHTMLXMLInput::isCompatibleVersion();
        else if ( $name == 'version' )
            $attr = eZDHTMLXMLInput::version();
        else if ( $name == 'required_version' )
            $attr = eZDHTMLXMLInput::requiredVersion();
        else if ( $name == 'ezpublish_version' )
            $attr = $this->eZPublishVersion;
        else
            $attr =& eZXMLInputHandler::attribute( $name );
        return $attr;
    }

    /*!
     \static
     \return true if the browser supports DHTML editing.
    */
    function browserSupportsDHTMLType()
    {
        $supportsDHTMLType = false;
        $userAgent = eZSys::serverVariable( 'HTTP_USER_AGENT' );

        if ( eregi('MSIE[ \/]([0-9\.]+)', $userAgent, $browserInfo ) )
        {
            $version = $browserInfo[1];
            if ( strpos( $userAgent, 'Windows NT 6.' ) !== false )
            {
                $supportsDHTMLType = 'Vista';
            }
            elseif ( $version >= 5.0 )
            {
                $supportsDHTMLType = "IE";
            }
        }
        elseif ( preg_match ("/opera/i", $userAgent ) )
             $supportsDHTMLType = false;

        elseif ( preg_match ("/gecko/i", $userAgent ) )
             $supportsDHTMLType = "Gecko";

        if ( preg_match ("/konqueror/i", $userAgent ) )
             $supportsDHTMLType = false;

        return $supportsDHTMLType;
    }

    /*!
     \static
     \return boolean
    */
    function isCompatibleVersion()
    {
        if ( $this->eZPublishVersion >= 3.5 )
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /*!
     \static
     \return OE version
    */
    function version()
    {
        $info = ezdhtmlInfo::info();
        $version = $info['version'];
        return $version;
    }

    /*!
     This function is deprecated, left for compatibility.
     \static
     \return eZ publish required OE version list
    */
    function requiredVersion()
    {
        $requiredVersion = false;
        include_once( 'kernel/common/ezoe.php' );
        if ( file_exists( 'kernel/common/ezoe.php' ) )
        {
            $requiredVersionList = eZOE::requiredVersionList();
            $requiredVersion = implode( "," , $requiredVersionList );
        }

        return $requiredVersion;
    }

    /*!
     \static
     \return true if the editor is enabled. The editor can be enabled/disabled by a
             button in the web interface.
    */
    function isEditorEnabled()
    {
        $dhtmlInput = true;
        $http =& eZHTTPTool::instance();
        if ( $http->hasSessionVariable( 'eZDHTMLXMLInputExtension' ) )
            $dhtmlInput = $http->sessionVariable( 'eZDHTMLXMLInputExtension' );
        return $dhtmlInput;
    }

    /*!
     Sets whether the DHTML editor is enabled or not.
    */
    function setIsEditorEnabled( $isEnabled )
    {
        $http =& eZHTTPTool::instance();
        $http->setSessionVariable( 'eZDHTMLXMLInputExtension', $isEnabled );
    }

    /*!
     \static
     \return true if the editor can be used. This is determinded by whether the browser supports DHTML and that
             the editor is enabled.
    */
    function isEditorActive()
    {
        if ( !eZDHTMLXMLInput::browserSupportsDHTMLType() )
            return false;

        return eZDHTMLXMLInput::isEditorEnabled();
    }

    /*!
     \reimp
    */
    function isValid()
    {
        return eZDHTMLXMLInput::browserSupportsDHTMLType();
    }

    /*!
     \reimp
    */
    function customObjectAttributeHTTPAction( $http, $action, &$contentObjectAttribute )
    {
        switch ( $action )
        {
            case 'enable_editor':
            {
                eZDHTMLXMLInput::setIsEditorEnabled( true );
            } break;
            case 'disable_editor':
            {
                eZDHTMLXMLInput::setIsEditorEnabled( false );
            } break;
            default :
            {
                eZDebug::writeError( 'Unknown custom HTTP action: ' . $action, 'eZDHTMLXMLInput' );
            } break;
        }
    }

    /*!
     \reimp
    */
    function &editTemplateSuffix( &$contentobjectAttribute )
    {
        $suffix = 'ezdhtml';
        return $suffix;
    }

    /*!
      Updates URL - object links.
    */
    function updateUrlObjectLinks( $contentObjectAttribute, $urlIDArray )
    {
        $objectAttributeID = $contentObjectAttribute->attribute( "id" );
        $objectAttributeVersion = $contentObjectAttribute->attribute('version');

        foreach( $urlIDArray as $urlID )
        {
            $linkObjectLink = eZURLObjectLink::fetch( $urlID, $objectAttributeID, $objectAttributeVersion );
            if ( $linkObjectLink == null )
            {
                $linkObjectLink = eZURLObjectLink::create( $urlID, $objectAttributeID, $objectAttributeVersion );
                $linkObjectLink->store();
            }
        }
    }

    /*!
     \reimp
    */
    function validateInput( &$http, $base, &$contentObjectAttribute )
    {
        $isGecko = false;
        $this->ContentObjectAttributeID = $contentObjectAttributeID = $contentObjectAttribute->attribute( "id" );
        $this->ContentObjectAttributeVersion = $contentObjectAttributeVersion = $contentObjectAttribute->attribute('version');

        if ( !$this->isEditorEnabled() )
        {
            $aliasedHandler =& $this->attribute( 'aliased_handler' );
            return $aliasedHandler->validateInput( $http, $base, $contentObjectAttribute );
        }
        if ( $http->hasPostVariable( $base . "_data_text_" . $contentObjectAttribute->attribute( "id" ) ) )
        {
            $text = $http->postVariable( $base . "_data_text_" . $contentObjectAttribute->attribute( "id" ) );

            $text = preg_replace( '#<!--.*?-->#s', '', $text ); // remove HTML comments
            $text = str_replace( "\r", '', $text);

            if ( $this->browserType == 'IE' )
                $text = preg_replace( "/[\n\t]/", '', $text);
            else
                $text = preg_replace( "/[\n\t]/", ' ', $text);

            //eZDebug::writeDebug( $text, 'HTML input' );

            include_once( 'extension/ezdhtml/lib/advdomnode.php' );
            include_once( 'extension/ezdhtml/ezxmltext/handlers/input/ezdhtmlinputparser.php' );

            $parser = new eZDHTMLInputParser();
            $parser->setDOMDocumentClass( 'advDOMDocument' );

            $document = $parser->process( $text );

            // Remove last empty paragraph (added in the output part)
            $parent =& $document->Root;
            $lastChild =& $parent->lastChild();
            while( $lastChild && $lastChild->nodeName != 'paragraph' )
            {
                $parent =& $lastChild;
                $lastChild =& $parent->lastChild();
            }

            if ( $lastChild && $lastChild->nodeName == 'paragraph' )
            {
                $textChild =& $lastChild->lastChild();
                if ( !$textChild ||
                     ( $lastChild->childrenCount() == 1 &&
                       $textChild->Type == EZ_XML_NODE_TEXT &&
                       ( $textChild->Content == ' ' || $textChild->Content == '' ) ) )
                {
                    $parent->removeChild( $lastChild );
                }
            }

            $classAttribute =& $contentObjectAttribute->contentClassAttribute();
            if ( $classAttribute->attribute( "is_required" ) == true )
            {
                $root =& $document->Root;
                if ( !count( $root->Children ) )
                {
                    $contentObjectAttribute->setValidationError( ezi18n( 'kernel/classes/datatypes',
                                                                         'Content required' ) );
                    return EZ_INPUT_VALIDATOR_STATE_INVALID;
                }
            }

            // Update URL-object links
            $urlIDArray = $parser->getUrlIDArray();
            if ( count( $urlIDArray ) > 0 )
            {
                $this->updateUrlObjectLinks( $contentObjectAttribute, $urlIDArray );
            }

            if ( $this->eZPublishVersion >= 3.9 )
            {
                $contentObject =& $contentObjectAttribute->attribute( 'object' );
                $contentObject->appendInputRelationList( $parser->getEmbeddedObjectIDArray(), EZ_CONTENT_OBJECT_RELATION_EMBED );
                $contentObject->appendInputRelationList( $parser->getLinkedObjectIDArray(), EZ_CONTENT_OBJECT_RELATION_LINK );
            }

            $xmlString = eZXMLTextType::domString( $document );

            //eZDebug::writeDebug( $xmlString, 'eZXML output' );

            $document->cleanup();

            $contentObjectAttribute->setAttribute( "data_text", $xmlString );
            $contentObjectAttribute->setValidationLog( $parser->Messages );

            return EZ_INPUT_VALIDATOR_STATE_ACCEPTED;
        }
        else
        {
            return EZ_INPUT_VALIDATOR_STATE_ACCEPTED;
        }
        return EZ_INPUT_VALIDATOR_STATE_INVALID;
    }


    /*

      Editor inner output implementation

    */

    // Get section level and reset cuttent node according to input header.
    function &sectionLevel( &$sectionLevel, $headerLevel, &$TagStack, &$currentNode, &$domDocument )
    {
        if ( $sectionLevel < $headerLevel )
        {
            if ( $this->IsStrictHeader )
            {
                $sectionLevel += 1;
            }
            else
            {
                if ( ( $sectionLevel + 1 ) == $headerLevel )
                {
                    $sectionLevel += 1;
                }
                else
                {
                    for ( $i=1;$i<=( $headerLevel - $sectionLevel - 1 );$i++ )
                    {
                        // Add section tag
                        unset( $subNode );
                        $subNode = new eZDOMNode();
                        $subNode->Name = "section";
                        $subNode->LocalName = "section";
                        $subNode->Type = EZ_NODE_TYPE_ELEMENT;
                        $domDocument->registerElement( $subNode );
                        $currentNode->appendChild( $subNode );
                        $childTag = $this->SectionArray;
                        $TagStack[] = array( "TagName" => "section", "ParentNodeObject" => &$currentNode, "ChildTag" => $childTag );
                        $currentNode =& $subNode;
                    }
                    $sectionLevel = $headerLevel;
                }
            }
        }
        elseif ( $sectionLevel == $headerLevel )
        {
            $lastNodeArray = array_pop( $TagStack );
            $lastNode =& $lastNodeArray["ParentNodeObject"];
            unset( $currentNode );
            $currentNode =& $lastNode;
            $sectionLevel = $headerLevel;
        }
        else
        {
            for ( $i=1;$i<=( $sectionLevel - $headerLevel + 1 );$i++ )
            {
                $lastNodeArray = array_pop( $TagStack );
                $lastTag = $lastNodeArray["TagName"];
                $lastNode =& $lastNodeArray["ParentNodeObject"];
                $lastChildTag = $lastNodeArray["ChildTag"];
                unset( $currentNode );
                $currentNode =& $lastNode;
            }
            $sectionLevel = $headerLevel;
        }
        return $currentNode;
    }

    /*!
     Returns the input XML representation of the datatype.
    */
    function &inputXML( )
    {
        $node = null;
        $xml  = new eZXML();

        $dom  =& $xml->domTree( $this->XMLData, array( 'ConvertSpecialChars' => false, 'TrimWhiteSpace' => false ) );

        if ( $dom )
            $node =& $dom->elementsByName( "section" );

        $output = "";
        if ( count( $node ) > 0 )
        {
            $output = "";
            //$children = $node[0]->children();
            $output .= $this->inputSectionXML( $node[0], 0 );
        }

        if ( $this->browserType == 'IE' )
            $output = str_replace( "<p></p>", "<p>&nbsp;</p>", $output );
        else
            $output = str_replace( "<p></p>", "<p><br/></p>", $output );

        $output = str_replace( "\n", "", $output );

        if ( $this->browserType == 'IE' )
            $output .= '<p>&nbsp;</p>';
        else
            $output .= '<p><br/></p>';

        //eZDebug::writeDebug( $output, '$output' );

        $output = htmlspecialchars( $output );

        return $output;
    }

    /*!
     \private
     \return the user input format for the given section
    */
    function &inputSectionXML( &$section, $currentSectionLevel, $tdSectionLevel = null )
    {
        $output = "";
        $imgName = "anchor_image.gif";

        $imgSrc = extension_path( 'ezdhtml', true, true, true );
        $imgSrc .= '/design/standard/images/ezdhtml/' . $imgName;

        foreach ( $section->children() as $sectionNode )
        {
            if ( $tdSectionLevel == null )
            {
                $sectionLevel = $currentSectionLevel;
            }
            else
            {
                $sectionLevel = $tdSectionLevel;
                $currentSectionLevel = $currentSectionLevel;
            }
            if ( get_class( $sectionNode ) == "ezdomnode" )
                $tagName = $sectionNode->name();
            else
                $tagName = "";
            switch ( $tagName )
            {
                case 'header' :
                {
                    $level = $sectionLevel;
                    $headerClassName = $sectionNode->attributeValue( 'class' );

                    if ( $headerClassName != null )
                        $headerClassString = " class='$headerClassName'";
                    else
                        $headerClassString = "";

                    $tagContent = '';
                    // render children tags
                    $tagChildren = $sectionNode->children();
                    foreach ( $tagChildren as $childTag )
                    {
                        $tagContent .= $this->inputTagXML( $childTag, $currentSectionLevel, $tdSectionLevel );
                    }

                    /*$tagContent = htmlspecialchars( $sectionNode->textContent() );
                    $tagContent = preg_replace( "#\n[ ]*#", '', $tagContent );

                    // A fix for IE
                    $tagContent = str_replace( '&amp;apos;', '&amp;#039;', $tagContent );
                    */

                    switch ( $level )
                    {
                        case "1":
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h1$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h1>";
                            else
                                $output .= "<h1$headerClassString>" . $tagContent . "</h1>";
                        }break;

                        case "2":
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h2$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h2>";
                            else
                                $output .= "<h2$headerClassString>" . $tagContent . "</h2>";
                        }break;

                        case "3":
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h3$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h3>";
                            else
                                $output .= "<h3$headerClassString>" . $tagContent . "</h3>";
                        }break;

                        case "4":
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h4$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h4>";
                            else
                                $output .= "<h4$headerClassString>" . $tagContent . "</h4>";
                        }break;

                        case "5":
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h5$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h5>";
                            else
                                $output .= "<h5$headerClassString>" . $tagContent . "</h5>";
                        }break;

                        case "6":
                        {
                            $archorName = $sectionNode->attributeValue( 'name' );
                            if ( $archorName != null )
                                $output .= "<h6$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h6>";
                            else
                                $output .= "<h6$headerClassString>" . $tagContent . "</h6>";
                        }break;

                        default:
                        {
                            $archorName = $sectionNode->attributeValue( 'anchor_name' );
                            if ( $archorName != null )
                                $output .= "<h1$headerClassString><img src=\"$imgSrc\" name=\"$archorName\" type=\"anchor\" />" . $sectionNode->textContent(). "</h1>";
                            else
                                $output .= "<h1$headerClassString>" . $tagContent . "</h1>";
                        }break;
                    }

                }break;

                case 'paragraph' :
                {
                    if ( $tdSectionLevel == null )
                        $output .= $this->inputParagraphXML( $sectionNode, $currentSectionLevel );
                    else
                        $output .= $this->inputParagraphXML( $sectionNode, $currentSectionLevel, $tdSectionLevel );
                }break;

                case 'section' :
                {
                    $sectionLevel += 1;
                    if ( $tdSectionLevel == null )
                        $output .= $this->inputSectionXML( $sectionNode, $sectionLevel );
                    else
                        $output .= $this->inputSectionXML( $sectionNode, $currentSectionLevel, $sectionLevel );
                }break;

                default :
                {
                    eZDebug::writeError( "Unsupported tag at this level: $tagName", "eZXMLTextType::inputSectionXML()" );
                }break;
            }
        }
        return $output;
    }

    /*!
     \private
     \return the user input format for the given table cell
    */
    function &inputListXML( &$listNode, $currentSectionLevel, $listSectionLevel = null, $noParagraphs = true )
    {
        $output = "";
        if ( get_class( $listNode ) == "ezdomnode" )
            $tagName = $listNode->name();
        else
            $tagName = "";
        switch ( $tagName )
        {
            case 'paragraph' :
            {
                $output .= $this->inputParagraphXML( $listNode, $currentSectionLevel, $listSectionLevel, $noParagraphs );
            }break;
            case 'section' :
            {
                $listSectionLevel += 1;
                $output .= $this->inputSectionXML( $tdNode, $currentSectionLevel, $listSectionLevel );
            }break;

            default :
            {
                eZDebug::writeError( "Unsupported tag at this level: $tagName", "eZXMLTextType::inputListXML()" );
            }break;
        }
        return $output;
    }

    /*!
     \private
     \return the user input format for the given section
    */
    function &inputTdXML( &$tdNode, $currentSectionLevel, $tdSectionLevel = null )
    {
        $output = "";
        if ( get_class( $tdNode ) == "ezdomnode" )
            $tagName = $tdNode->name();
        else
            $tagName = "";
        switch ( $tagName )
        {
            case 'paragraph' :
            {
                $output .= $this->inputParagraphXML( $tdNode, $currentSectionLevel, $tdSectionLevel  );
            }break;
            case 'section' :
            {
                $tdSectionLevel += 1;
                $output .= $this->inputSectionXML( $tdNode, $currentSectionLevel, $tdSectionLevel );
            }break;
            default :
            {
                eZDebug::writeError( "Unsupported tag at this level: $tagName", "eZXMLTextType::inputTdXML()" );
            }break;
        }
        return $output;
    }

    /*!
     \return the input xml of the given paragraph
    */
    function &inputParagraphXML( &$paragraph, $currentSectionLevel, $tdSectionLevel = null, $noRender = false )
    {
        $output = '';
        $children =& $paragraph->Children;
        if ( $noRender )
        {
            foreach ( $children as $key=>$child )
            {
                $output .= $this->inputTagXML( $child, $currentSectionLevel, $tdSectionLevel );
            }
            return $output;
        }

        $paragraphClassName = $paragraph->attributeValue( 'class' );

        $customAttributePart = $this->getCustomAttrPart( $paragraph );

        if ( $paragraphClassName != null )
            $openPara = "<p class='$paragraphClassName'$customAttributePart>";
        else
            $openPara = "<p$customAttributePart>";
        $closePara = '</p>';

        if ( !count( $children ) )
        {
            $output = $openPara . $closePara;
            return $output;
        }

        $lastChildInline = null;
        $innerContent = '';
        foreach ( $children as $key=>$child )
        {
            $childOutput = $this->inputTagXML( $child, $currentSectionLevel, $tdSectionLevel );

            $inline = !( $child->Name == 'ul' || $child->Name == 'ol');
            if ( $inline )
                $innerContent .= $childOutput;

            if ( ( !$inline && $lastChildInline ) ||
                 ( $inline && !array_key_exists( $key + 1, $children ) ) )
            {
                $output .= $openPara . $innerContent . $closePara;
                $innerContent = '';
            }

            if ( !$inline )
                $output .= $childOutput;

            $lastChildInline = $inline;
        }

        return $output;
    }

    function getCustomAttrPart( $tag )
    {
        $customAttributePart = "";
        $customAttributes =& $tag->attributesNS( "http://ez.no/namespaces/ezpublish3/custom/" );
        if ( $customAttributes != null )
        {
            $customAttributePart = " customAttributes=\"";
            $customAttributePart .= $customAttributes[0]->name() . "|" . $customAttributes[0]->content();
            for ( $i=1;$i<count($customAttributes);$i++ )
            {
               $customAttributePart .= 'attribute_separation' . $customAttributes[$i]->name() . "|" . $customAttributes[$i]->content();
            }
            $customAttributePart .= "\"";
        }
        return $customAttributePart;
    }

    /*!
     \return the input xml for the given tag
    */
    function &inputTagXML( &$tag, $currentSectionLevel, $tdSectionLevel = null )
    {
        $output = "";
        $tagName = $tag->name();
        $childTagText = "";
        // render children tags
        $tagChildren = $tag->children();
        foreach ( $tagChildren as $childTag )
        {
            $childTagText .= $this->inputTagXML( $childTag, $currentSectionLevel, $tdSectionLevel );
        }
        switch ( $tagName )
        {
            case '#text' :
            {
                //$tagContent = htmlspecialchars( $tag->content() );
                $tagContent = $tag->content();
                if ( !strlen( $tagContent ) )
                    break;

                if ( $this->allowMultipleSpaces )
                    $tagContent = str_replace( "  ", " &nbsp;", $tagContent );
                else
                    $tagContent = preg_replace( "/ {2,}/", " ", $tagContent );

                if ( $tagContent[0] == ' ' )
                {
                    $tagContent[0] = ';';
                    $tagContent = '&nbsp' . $tagContent;
                }

                // A fix for IE
                $tagContent = str_replace( '&apos;', '&#039;', $tagContent );

                $output .= $tagContent;

            }break;
            
            case 'object' :
            {
                $size = "";
                $view = $tag->attributeValue( 'view' );
                $size = $tag->attributeValue( 'size' );
                $alignment = $tag->attributeValue( 'align' );
                $className = $tag->attributeValue( 'class' );
                $optionalLinkParameters = "";
                $hasLink = false;
                $linkID = $tag->attributeValueNS( 'ezurl_id', "http://ez.no/namespaces/ezpublish3/image/" );

                if ( $linkID != null )
                {
                    $href =& eZURL::url( $linkID );
                    $target = $tag->attributeValueNS( 'ezurl_target', "http://ez.no/namespaces/ezpublish3/image/" );
                    if ( $target == null )
                        $target = "_self";
                    $title = $tag->attributeValueNS( 'ezurl_title', "http://ez.no/namespaces/ezpublish3/image/" );
                    $id = $tag->attributeValueNS( 'ezurl_linkid', "http://ez.no/namespaces/ezpublish3/image/" );
                    $hasLink = true;
                    if ( $title != null )
                    {
                        $optionalLinkParameters .= " title=" . $title;
                    }
                    if ( $id != null )
                    {
                        $optionalLinkParameters .= " id=" . $id;
                    }
                }

                $customAttributePart = "";
                $customAttributes =& $tag->attributesNS( "http://ez.no/namespaces/ezpublish3/custom/" );
                if ( $customAttributes != null )
                {
                    $customAttributePart = "customAttributes=\"";
                    $customAttributePart .= $customAttributes[0]->name() . "|" . $customAttributes[0]->content();
                    for ( $i=1;$i<count($customAttributes);$i++ )
                    {
                       $customAttributePart .= 'attribute_separation' . $customAttributes[$i]->name() . "|" . $customAttributes[$i]->content();
                    }
                    $customAttributePart .= "\"";
                }

                if ( strlen( $view ) == 0 )
                    $view = "embed";
                $srcString = "";
                $objectID = $tag->attributeValue( 'id' );
                $object =& eZContentObject::fetch( $objectID );

                if ( $object != null )
                {
                    $objectName = $object->attribute( 'name' );
                    $classID = $object->attribute( 'contentclass_id' );
                }
                else
                {
                    $objectName = "Unknow";
                    $classID = 0;
                }
                
                $URL = serverURL();
                
                $ini =& eZINI::instance( 'site.ini' );
                $imageClassArray = $ini->variable("MediaClassSettings", "ImageClassID" );
                $imageDatatypeArray = $ini->variable( "ImageDataTypeSettings", "AvailableImageDataTypes" );
                if ( in_array( $classID, $imageClassArray ) )
                {
                    $contentObjectAttributes =& $object->contentObjectAttributes();
                    foreach ( $contentObjectAttributes as $contentObjectAttribute )
                    {
                        $classAttribute =& $contentObjectAttribute->contentClassAttribute();
                        $dataTypeString = $classAttribute->attribute( 'data_type_string' );
                        if ( in_array ( $dataTypeString, $imageDatatypeArray ) )
                        {
                            $contentObjectAttributeID = $contentObjectAttribute->attribute( 'id' );
                            $contentObjectAttributeVersion = $contentObjectAttribute->attribute( 'version' );
                            $content = $contentObjectAttribute->content();
                            if ( $content != null )
                            {
                                if ( $size == "" )
                                    $size = "medium";
                                $imageAlias = $content->imageAlias( $size );
                                $srcString = $URL . '/' . $imageAlias['url'];
                            }
                            else
                            {
                                $srcString = "";
                            }
                        }
                    }
                }
                else
                {
                    $srcString = $URL . "/";;
                    $srcString .= extension_path( 'ezdhtml', false, false, false );
                    $srcString .= '/design/standard/images/ezdhtml/object_insert.png';
                }
                if ( $className != null )
                {
                    if ( $size == "" )
                        $output .= "<img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" class='$className' $customAttributePart />";
                    else if ( $size != "" and $hasLink )
                        $output .= "<a href='$href' target='$target'$optionalLinkParameters><img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" alt=\"$size\" class='$className' $customAttributePart /></a>";
                    else
                        $output .= "<img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" alt=\"$size\" class='$className' $customAttributePart />";
                }
                else
                {
                    if ( $size == "" )
                        $output .= "<img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" $customAttributePart />";
                    else if ( $size != "" and $hasLink )
                        $output .= "<a href='$href' target='$target'$optionalLinkParameters><img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" alt=\"$size\" $customAttributePart /></a>";
                    else
                        $output .= "<img id=\"eZObject_$objectID\" src=\"$srcString\" align=\"$alignment\" alt=\"$size\" $customAttributePart />";
                }
            }break;

            case 'embed' :
            case 'embed-inline' :
            {
                $view = $tag->attributeValue( 'view' );
                $size = $tag->attributeValue( 'size' );
                $alignment = $tag->attributeValue( 'align' );
                if ( !$alignment )
                    $alignment = 'right';

                $objectID = $tag->attributeValue( 'object_id' );
                $nodeID = $tag->attributeValue( 'node_id' );
                $showPath = $tag->attributeValue( 'show_path' );
                $htmlID = $tag->attributeValueNS( 'id', 'http://ez.no/namespaces/ezpublish3/xhtml/' );
                $className = $tag->attributeValue( 'class' );
                $linkToObject = true;

                $objectAttr = "";

                if ( $size != null )
                    $objectAttr .= " alt='$size'";
                else
                {
                    $objectAttr .= " alt='medium'";
                    $size = "medium";
                }
                if ( $alignment != null )
                    $objectAttr .= " align='$alignment'";
                if ( $view != null )
                    $objectAttr .= " view='$view'";
                if ( $htmlID != '' )
                    $objectAttr .= " html_id='$htmlID'";
                if ( $className != '' )
                    $objectAttr .= " class='$className'";
                if ( $showPath == 'true' )
                    $objectAttr .= " show_path='true'";

                if ( $this->eZPublishVersion >= 3.8 )
                {
                    if ( $tagName == 'embed-inline' )
                    {
                        $objectAttr .= " inline='true'";
                    }
                    else
                    {
                        $objectAttr .= " inline='false'";
                    }
                }
                
                $customAttributePart = $this->getCustomAttrPart( $tag );

                if ( is_numeric( $objectID ) )
                {
                    $object =& eZContentObject::fetch( $objectID );
                }
                elseif ( is_numeric( $nodeID ) )
                {
                    $linkToObject = false;
                    $object =& eZContentObject::fetchByNodeID( $nodeID );
                }

                if ( $object != null )
                {
                    $objectName = $object->attribute( 'name' );
                    $classID = $object->attribute( 'contentclass_id' );
                }
                else
                {
                    $objectName = "Unknow";
                    $classID = 0;
                }

                $URL = serverURL();

                $ini =& eZINI::instance( 'site.ini' );
                $imageClassArray = $ini->variable("MediaClassSettings", "ImageClassID" );
                $imageDatatypeArray = $ini->variable( "ImageDataTypeSettings", "AvailableImageDataTypes" );
                if ( in_array( $classID, $imageClassArray ) )
                {
                    $contentObjectAttributes =& $object->contentObjectAttributes();
                    foreach ( $contentObjectAttributes as $contentObjectAttribute )
                    {
                        $classAttribute =& $contentObjectAttribute->contentClassAttribute();
                        $dataTypeString = $classAttribute->attribute( 'data_type_string' );
                        if ( in_array ( $dataTypeString, $imageDatatypeArray ) )
                        {
                            $contentObjectAttributeID = $contentObjectAttribute->attribute( 'id' );
                            $contentObjectAttributeVersion = $contentObjectAttribute->attribute( 'version' );
                            $content = $contentObjectAttribute->content();
                            if ( $content != null )
                            {
                                $imageAlias = $content->imageAlias( $size );
                                $srcString = $URL . '/' . $imageAlias['url'];
                            }
                            else
                            {
                                $srcString = "";
                            }
                        }
                    }
                }
                else
                {
                    $srcString = $URL . "/";;
                    $srcString .= extension_path( 'ezdhtml', false, false, false );
                    $srcString .= '/design/standard/images/ezdhtml/object_insert.png';
                }

                if ( $linkToObject )
                {
                    $output .= "<img id=\"eZObject_$objectID\" src=\"$srcString\" $objectAttr$customAttributePart />";
                }
                else
                {
                    $output .= "<img id=\"eZNode_$nodeID\" src=\"$srcString\" $objectAttr$customAttributePart />";
                }
            }break;

            case 'anchor' :
            {
                $name = $tag->attributeValue( 'name' );
                $imgName = "anchor_image.gif";

                $customAttributePart = $this->getCustomAttrPart( $tag );

                $src = imagePath( $imgName );
                $output .= "<img src=\"$src\" name=\"$name\" type=\"anchor\"$customAttributePart/>";
            }break;

            case 'custom' :
            {
                $name = $tag->attributeValue( 'name' );

                $customAttributePart = $this->getCustomAttrPart( $tag );
                
                $isInline = false;
                include_once( "lib/ezutils/classes/ezini.php" );
                $ini =& eZINI::instance( 'content.ini' );

                $isInlineTagList = $ini->variable( 'CustomTagSettings', 'IsInline' );
                foreach ( array_keys ( $isInlineTagList ) as $key )
                {
                    $isInlineTagValue =& $isInlineTagList[$key];
                    if ( $isInlineTagValue )
                    {
                        if ( $name == $key )
                            $isInline = true;
                    }
                }

                if ( $isInline )
                {
                    $imgName = "customtag_insert.gif";

                    if ( !$childTagText )
                    {
                        $src = imagePath( $imgName );
                        $output .= "<img src=\"$src\" name=\"$name\" value=\"\" type=\"custom\"$customAttributePart />";
                    }
                    else
                    {
                        $output .= "<span class=\"$name\" name=\"$name\" type=\"custom\"$customAttributePart>$childTagText</span>";
                    }
                }
                else
                {
                    $customTagContent = "";
                    foreach ( $tag->children() as $tagChild )
                    {
                        $customTagContent .= $this->inputTdXML( $tagChild, $currentSectionLevel, $tdSectionLevel );
                    }
                    $output .= "<table id='custom' class='custom' title='$name' width='100%' border='1'$customAttributePart><tr><td class='" . $name . "'>$customTagContent</td></tr></table>";
                }
            }break;

            case 'literal' :
            {
                $literalText = "";
                foreach ( $tagChildren as $childTag )
                {
                    $literalText .= $childTag->content();
                }
                $className = $tag->attributeValue( 'class' );

                $customAttributePart = $this->getCustomAttrPart( $tag );

                //$literalText = htmlspecialchars( $literalText );

                $literalText = str_replace( "  ", " &nbsp;", $literalText );
                $literalText = str_replace( "\n\n", "</p><p>", $literalText );
                $literalText = str_replace( "\n", "<br>", $literalText );
                //$literalText = htmlspecialchars( $literalText );

                // A fix for IE
                $literalText = str_replace( '&apos;', '&#039;', $literalText );

                if ( $className == null )
                    $output .= "<table id='literal' width='100%' border='1' class='literal'$customAttributePart><tr><td><p>$literalText</p></td></tr></table>";
                else
                    $output .= "<table id='literal' width='100%' border='1' class='literal' title='$className'$customAttributePart><tr><td class='$className'><p>$literalText</p></td></tr></table>";
            }break;

            case 'ul' :
            case 'ol' :
            {
                $listContent = "";

                $customAttributePart = $this->getCustomAttrPart( $tag );

                // find all list elements
                foreach ( $tag->children() as $listItemNode )
                {
                    $LIcustomAttributePart = $this->getCustomAttrPart( $listItemNode );

                    $noParagraphs = count( $listItemNode->children() ) <= 1;
                    $listItemContent = "";
                    foreach ( $listItemNode->children() as $itemChildNode )
                    {
                        $listSectionLevel = $currentSectionLevel;
                        if ( $itemChildNode->name() == "section" or $itemChildNode->name() == "paragraph" )
                            $listItemContent .= $this->inputListXML( $itemChildNode, $currentSectionLevel, $listSectionLevel, $noParagraphs );
                        else
                            $listItemContent .= $this->inputTagXML( $itemChildNode, $currentSectionLevel, $tdSectionLevel );
                    }
                    /*foreach ( $listItemNode->children() as $itemChildNode )
                    {
                        $listItemContent .= $this->inputTagXML( $itemChildNode, $currentSectionLevel, $tdSectionLevel );
                    }*/
                    $listContent .= "<li$LIcustomAttributePart>$listItemContent</li>";
                }
                $className = $tag->attributeValue( 'class' );
                if ( $className != null )
                    $output .= "<$tagName class='$className'$customAttributePart>$listContent</$tagName>";
                else
                    $output .= "<$tagName$customAttributePart>$listContent</$tagName>";
            }break;

            case 'table' :
            {
                $tableRows = "";
                $border = $tag->attributeValue( 'border' );
                $width = $tag->attributeValue( 'width' );
                $tableClassName = $tag->attributeValue( 'class' );

                $customAttributePart = $this->getCustomAttrPart( $tag );

                // find all table rows
                foreach ( $tag->children() as $tableRow )
                {
                    $TRcustomAttributePart = $this->getCustomAttrPart( $tableRow );

                    $tableData = "";
                    foreach ( $tableRow->children() as $tableCell )
                    {
                        $TDcustomAttributePart = $this->getCustomAttrPart( $tableCell );

                        $cellAttribute = "";
                        $className = $tableCell->attributeValue( 'class' );

                        $colspan = $tableCell->attributeValueNS( 'colspan', "http://ez.no/namespaces/ezpublish3/xhtml/" );
                        $rowspan = $tableCell->attributeValueNS( 'rowspan', "http://ez.no/namespaces/ezpublish3/xhtml/" );
                        $cellWidth = $tableCell->attributeValueNS( 'width', "http://ez.no/namespaces/ezpublish3/xhtml/" );
                        if ( $className != null )
                            $cellAttribute .= " class='$className'";
                        if ( $cellWidth != null )
                            $cellAttribute .= " width='$cellWidth'";
                        if ( $colspan != null )
                            $cellAttribute .= " colspan='$colspan'";
                        if ( $rowspan != null )
                            $cellAttribute .= " rowspan='$rowspan'";
                        $cellContent = "";
                        if ( $tableCell->Name == "th" )
                        {
                            $tdSectionLevel = $currentSectionLevel;
                            foreach ( $tableCell->children() as $tableCellChildNode )
                            {
                                $cellContent .= $this->inputTdXML( $tableCellChildNode, $currentSectionLevel, $tdSectionLevel - $currentSectionLevel );
                            }
                            $tableData .= "<th" . $cellAttribute . $TDcustomAttributePart . ">" . $cellContent . "</th>";

                        }
                        else
                        {
                            $tdSectionLevel = $currentSectionLevel;
                            foreach ( $tableCell->children() as $tableCellChildNode )
                            {
                                $cellContent .= $this->inputTdXML( $tableCellChildNode, $currentSectionLevel, $tdSectionLevel - $currentSectionLevel );
                            }
                            $tableData .= "<td" . $cellAttribute . $TDcustomAttributePart . ">" . $cellContent . "</td>";
                        }
                    }
                    $tableRows .= "<tr$TRcustomAttributePart>$tableData</tr>";
                }
                if ( $this->browserSupportsDHTMLType() == "Gecko" )
                {
                    $widthAttribute = "style='width: $width;'";
                }
                else
                {
                    $widthAttribute = "width='$width'";
                }

                if ( is_string( $border ) )
                {
                    $borderAttribute = "ezborder='$border'";
                    if ( $border == 0 )
                        $borderAttribute .= " border='1' bordercolor='red'";
                    else
                        $borderAttribute .= " border='$border'";
                }
                else
                    $borderAttribute = "";

                if ( $tableClassName != null )
                    $classAttribute = "class='$tableClassName'";
                else
                    $classAttribute = "";

                $output .= "<table id='table' $classAttribute $widthAttribute $borderAttribute$customAttributePart>$tableRows</table>";
            }break;

            // normal content tags
            case 'emphasize' :
            {
                $customAttributePart = $this->getCustomAttrPart( $tag );

                $className = $tag->attributeValue( 'class' );
                if ( $className != null )
                    $output .= "<i class='$className'$customAttributePart>" . $childTagText . "</i>";
                else
                $output .= "<i>" . $childTagText  . "</i>";
            }break;

            case 'strong' :
            {
                $customAttributePart = $this->getCustomAttrPart( $tag );

                $className = $tag->attributeValue( 'class' );
                if ( $className != null )
                    $output .= "<b class='$className'$customAttributePart>" . $childTagText . "</b>";
                else
                    $output .= "<b>" . $childTagText . "</b>";
            }break;

            case 'line' :
            {
                $output .= $childTagText . "<br />";
            }break;

            case 'link' :
            {
                $customAttributePart = $this->getCustomAttrPart( $tag );

                if ( $this->eZPublishVersion >= 3.6 )
                    $linkID = $tag->attributeValue( 'url_id' );
                else
                    $linkID = $tag->attributeValue( 'id' );
                $target = $tag->attributeValue( 'target' );
                $className = $tag->attributeValue( 'class' );
                $viewName = $tag->attributeValue( 'view' );
                $objectID = $tag->attributeValue( 'object_id' );
                $nodeID = $tag->attributeValue( 'node_id' );
                $anchorName = $tag->attributeValue( 'anchor_name' );
                $showPath = $tag->attributeValue( 'show_path' );
                $htmlID = $tag->attributeValueNS( 'id', 'http://ez.no/namespaces/ezpublish3/xhtml/' );
                $htmlTitle = $tag->attributeValueNS( 'title', 'http://ez.no/namespaces/ezpublish3/xhtml/' );

                if ( $objectID != null )
                {
                    $href = 'ezobject://' .$objectID;
                }
                elseif ( $nodeID != null )
                {
                        if ( $showPath == 'true' )
                    {
                            $node = eZContentObjectTreeNode::fetch( $nodeID );
                            if ( $node )
                                $href = 'eznode://' . $node->attribute('path_identification_string');
                            else
                                $href = 'eznode://' . $nodeID;
                            }
                        else
                            $href = 'eznode://' . $nodeID;
                }
                elseif ( $linkID != null )
                {
                    $href = eZURL::url( $linkID );
                }
                else
                {
                    $href = $tag->attributeValue( 'href' );
                }

                if ( $anchorName != null )
                {
                    $href .= '#' .$anchorName;
                }

                $attributes = array();
                if ( $className != '' )
                    $attributes[] = "class='$className'";
                if ( $viewName != '' )
                    $attributes[] = "view='$viewName'";

                $attributes[] = "href='$href'";
                if ( $target != '' )
                    $attributes[] = "target='$target'";
                if ( $htmlTitle != '' )
                    $attributes[] = "title='$htmlTitle'";
                if ( $htmlID != '' )
                    $attributes[] = "id='$htmlID'";

                $attributeText = '';
                if ( count( $attributes ) > 0 )
                    $attributeText = ' ' .implode( ' ', $attributes );
                $output .= "<a$attributeText$customAttributePart>" . $childTagText . "</a>";
            }break;
            case 'tr' :
            case 'td' :
            case 'th' :
            case 'li' :
            case 'paragraph' :
            {
            }break;
            default :
            {
                //eZDebug::writeDebug( "Unsupported tag: $tagName", "eZXMLTextType::inputTagXML()" );
            }break;
        }
        return $output;
    }


    var $LineTagArray = array( 'emphasize', 'strong', 'link', 'a', 'em', 'i', 'b', 'bold','anchor' );
    /// Contains the XML data
    var $XMLData;

    var $ContentObjectAttributeID;
    var $ContentObjectAttributeVersion;

    var $IsStrictHeader = false;
    var $SectionArray = array(  "h1", "h2", "h3", "h4", "h5", "h6", "p", "section" );

    var $browserType;
    var $eZPublishVersion;

    var $trimSpaces = true;
    var $allowMultipleSpaces = false;
}

?>
